package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingClaseDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingClase;
import com.rjconsultores.ventaboletos.service.GP_PricingClaseService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingClaseService")
public class GP_PricingClaseServiceImpl implements GP_PricingClaseService {

    @Autowired
    private GP_PricingClaseDAO pricingClaseDAO;

    public List<GP_PricingClase> obtenerTodos() {
        return pricingClaseDAO.obtenerTodos();
    }

    public GP_PricingClase obtenerID(Integer id) {
        return pricingClaseDAO.obtenerID(id);
    }

    @Transactional
    public GP_PricingClase suscribir(GP_PricingClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingClaseDAO.suscribir(entidad);
    }

    @Transactional
    public GP_PricingClase actualizacion(GP_PricingClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.ATIVO);

        return pricingClaseDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(GP_PricingClase entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(GP_Pricing.EXCLUIDO);

        pricingClaseDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingClase(GP_Pricing pricing, ClaseServicio claseServicio) {
        return pricingClaseDAO.obtenerPricingClase(pricing, claseServicio);
    }
    
    public List<GP_PricingClase> obtenerTodoPorPricing(GP_Pricing pricing) {
    	return pricingClaseDAO.obtenerTodoPorPricing(pricing);
	}
}
